/* libStreamedXML/src/lib/Core/Exceptions.cpp
 *
 *  (c)2005, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

namespace lsx {



Exception::Exception(const std::wstring& reason)
    : reason(reason)
{
}



const char* Exception::what()
{
    if(utf8Reason.empty()) utf8Reason = utf8::encode(reason, true);
    return utf8Reason.c_str();
}



NotWellFormed::NotWellFormed(const std::wstring& error)
    : Exception(format(error)), error(error)
{
}



std::wstring NotWellFormed::format(const std::wstring& error)
{
    std::wostringstream ost;
    ost << L"Streamed XML is not well formed:\n"
        << error;
    return ost.str();
}



UnknownEntity::UnknownEntity(const std::wstring& name)
    : Exception(format(name)), name(name)
{
}



std::wstring UnknownEntity::format(const std::wstring& name)
{
    std::wostringstream ost;
    ost << L"Encountered an unknown entity named '"
        << name
        << L"' in the Streamed XML.";
    return ost.str();
}



}
